"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EncryptionSessionRetrievalFlow = void 0;
/* global fetch */
require("./patches");
const utils_1 = require("./utils");
const async_storage_1 = __importDefault(require("@react-native-async-storage/async-storage"));
// Seald SDK
require("@seald-io/sdk/lib/declarations");
const main_js_1 = require("@seald-io/sdk/lib/main.js");
const sscryptoForge = __importStar(require("sscrypto/forge"));
const sscryptoWebcrypto = __importStar(require("sscrypto/webcrypto"));
// SDK local database
const nedbclient_1 = __importDefault(require("follicle/build/lib/clients/nedbclient"));
const createNeDbClient = (databasePath, serializationHooks) => nedbclient_1.default.connect(databasePath || 'nedb://memory', serializationHooks);
const readKeyBackup = async (databasePath) => {
    if (databasePath) {
        const keyBackup = await async_storage_1.default.getItem(`${databasePath}/SealdKeyBackup`);
        return keyBackup ? Buffer.from(keyBackup, 'base64') : null;
    }
    return null;
};
const writeKeyBackup = async (databasePath, encryptedKeyBackup) => {
    if (databasePath) {
        if (encryptedKeyBackup)
            await async_storage_1.default.setItem(`${databasePath}/SealdKeyBackup`, encryptedKeyBackup.toString('base64'));
        else
            await async_storage_1.default.removeItem(`${databasePath}/SealdKeyBackup`);
    }
};
exports.default = ({ apiURL, hairlessURL, appId, nedbClient, sscrypto, getRSAKeyPromise, scrypt, databasePath, databaseKey, databaseRawKey, shouldWaterfallApi, plugins, keySize, createEncryptionSessionCache, encryptionSessionCacheTTL, encryptionSessionCacheCleanupInterval }) => {
    return (0, main_js_1.SDK)({
        platform: 'react-native',
        fetch,
        sscrypto: sscrypto || ((0, utils_1.isChromeDebugger)() ? sscryptoWebcrypto : sscryptoForge),
        getRSAKeyPromise: getRSAKeyPromise !== undefined // if `null`, we must pass it
            ? getRSAKeyPromise
            : ((0, utils_1.isChromeDebugger)() ? undefined : utils_1.getRSAKeyPromise),
        scrypt: scrypt || utils_1.scrypt,
        nedbClient,
        createNeDbClient,
        databasePath,
        databaseKey,
        databaseRawKey,
        apiURL,
        hairlessURL,
        appId,
        shouldWaterfallApi,
        plugins,
        keySize,
        createEncryptionSessionCache,
        encryptionSessionCacheTTL,
        encryptionSessionCacheCleanupInterval,
        readKeyBackup,
        writeKeyBackup
    });
};
// SDK Enums
var main_1 = require("@seald-io/sdk/lib/main");
Object.defineProperty(exports, "EncryptionSessionRetrievalFlow", { enumerable: true, get: function () { return main_1.EncryptionSessionRetrievalFlow; } });
//# sourceMappingURL=seald-sdk-react-native.js.map